import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import say.swing.*;

import java.io.*;

public class Editor02 extends JFrame {
	JTextPane jtp = newJTextPane();

	private JTextPane newJTextPane(){
		JTextPane jtp = new JTextPane();
		jtp.setBackground(Color.white);
		jtp.setPreferredSize(new Dimension(300, 400));
		return jtp;
	}

	public Editor02(){
		super("Editor02");
		setDefaultCloseOperation(EXIT_ON_CLOSE);

		final Container pane = getContentPane();
		Color fcol = Color.black;
		Color bcol = Color.white;


		final JFileChooser jfic = new JFileChooser(".");
		final JFontChooser jfoc = new JFontChooser();
		final JColorChooser jcoc = new JColorChooser();

		// MenuBar
		JMenuBar jmb = new JMenuBar();
		JMenu jm1 = new JMenu("ファイル");
		jm1.add(new AbstractAction("新規"){
			public void actionPerformed(ActionEvent ev){
				pane.remove(jtp);
				jtp = newJTextPane();
				pane.add(jtp, BorderLayout.SOUTH);
				pack();
			}
		});
		jm1.add(new AbstractAction("開く"){
			public void actionPerformed(ActionEvent ev){
				try{
					if(jfic.showOpenDialog(pane) == JFileChooser.APPROVE_OPTION){
						File f = jfic.getSelectedFile();
						pane.remove(jtp);
						jtp = (JTextPane)(new ObjectInputStream(new FileInputStream(f)).readObject());
						pane.add(jtp, BorderLayout.SOUTH);
						pack();
					}
				}catch(Exception ex){
					ex.printStackTrace();
				}
			}
		});
		jm1.add(new AbstractAction("保存"){
			public void actionPerformed(ActionEvent ev){
				try{
					if(jfic.showSaveDialog(pane) == JFileChooser.APPROVE_OPTION){
						File f = jfic.getSelectedFile();
						new ObjectOutputStream(new FileOutputStream(f)).writeObject(jtp);
					}
				}catch(Exception ex){
					ex.printStackTrace();
				}
			}
		});
		jm1.add(new AbstractAction("終了"){
			public void actionPerformed(ActionEvent ev){
				System.exit(0);
			}
		});
		jmb.add(jm1);

		JMenu jm2 = new JMenu("書式");
		JMenu jm21 = new JMenu("文字");
		jm21.add(new AbstractAction("前景色"){
			public void actionPerformed(ActionEvent ev){
				Color c = jcoc.showDialog(pane, "色を選択して下さい", Color.black);
				if(c != null){
					SimpleAttributeSet sas = new SimpleAttributeSet();
					StyleConstants.setForeground(sas, c);
					jtp.setCharacterAttributes(sas, false);
				}
			}
		});
		jm21.add(new AbstractAction("背景色"){
			public void actionPerformed(ActionEvent ev){
				Color c = jcoc.showDialog(pane, "色を選択して下さい", Color.white);
				if(c != null){
					SimpleAttributeSet sas = new SimpleAttributeSet();
					StyleConstants.setBackground(sas, c);
					jtp.setCharacterAttributes(sas, false);
				}
			}
		});
		jm21.add(new AbstractAction("フォント"){
			public void actionPerformed(ActionEvent ev){
				if(jfoc.showDialog(pane) == JFontChooser.OK_OPTION){
					Font f = jfoc.getSelectedFont();
					SimpleAttributeSet sas = new SimpleAttributeSet();
					//StyleConstants.setFontFamily(sas, f.getFamily());
					StyleConstants.setFontSize(sas, f.getSize());
					StyleConstants.setBold(sas, f.isBold());
					StyleConstants.setItalic(sas, f.isItalic());
					jtp.setCharacterAttributes(sas, false);
				}
			}
		});
		JMenu jm22 = new JMenu("文書");
		jm22.add(new AbstractAction("背景色"){
			public void actionPerformed(ActionEvent ev){
				Color c = jcoc.showDialog(pane, "色を選択して下さい", Color.white);
				if(c != null){
					jtp.setBackground(c);
				}
			}
		});
		jm2.add(jm21);
		jm2.add(jm22);
		jmb.add(jm2);

		JMenu jm3 = new JMenu("挿入");
		jm3.add(new AbstractAction("画像"){
			public void actionPerformed(ActionEvent ev){
				try{
					if(jfic.showOpenDialog(pane) == JFileChooser.APPROVE_OPTION){
						File f = jfic.getSelectedFile();
						System.out.println(f.getPath());
						jtp.insertIcon(new ImageIcon(f.getPath()));
					}
				}catch(Exception ex){
				}
			}
		});
		jmb.add(jm3);

		pane.add(jmb, BorderLayout.NORTH);
		pane.add(jtp, BorderLayout.SOUTH);
		pack();
		setVisible(true);
	}

	public static void main(String[] args){
		new Editor02();
	}
}
