import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import javax.swing.*;

public class MySwingApp extends JFrame {
    class Canvas extends JPanel {
		public Canvas() {
		    setSize(getPreferredSize());
		    setBackground(Color.white);
		}
		
		public Dimension getPreferredSize() {
		    return new Dimension(600, 600);
		}
		
		public void paintComponent(Graphics g) {
		    super.paintComponent(g);
		    Graphics2D g2d = (Graphics2D) g;
		    Ellipse2D circle = new Ellipse2D.Double(0d, 0d, 100d, 100d);
		    g2d.setColor(Color.red);
		    g2d.translate(10, 10);
		    g2d.draw(circle);
		    g2d.fill(circle);
		}
    }
    
    public MySwingApp() {
		super("Swing Application generate by JDE");
		setSize(300, 300);
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {System.exit(0);}
			public void windowOpened(WindowEvent e) {}
		    });
		setJMenuBar(createMenu());
		getContentPane().add(new JScrollPane(new Canvas()));
    }
    
    public static void main(String[] args) {
		MySwingApp f = new MySwingApp();
		f.show();
    }
    
    protected JMenuBar createMenu() {
	JMenuBar mb = new JMenuBar();
	JMenu menu = new JMenu("File");
	menu.add(new AbstractAction("Exit") {
		public void actionPerformed(ActionEvent e) {
		    System.exit(0);
		}
	    });
	mb.add(menu);
	return mb;
    }
} // MySwingApp
