import java.io.*;
import java.util.*;
import java.sql.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;

class Select01 extends JFrame {
	private static String table;

	public static void main(String[] args){
		table = args[0];
		new Select01();
	}

	Select01(){
		try{
			/*
			 * ACCESS DATABASE
			 */
			ResourceBundle rb = ResourceBundle.getBundle("postgresql");
			Class.forName(rb.getString("driver"));
			String jdbc = rb.getString("jdbc");
			String dtbs = rb.getString("dtbs");
			String user = rb.getString("usnm");
			String pass = rb.getString("pswd");
			Connection co = DriverManager.getConnection(jdbc + dtbs, user, pass);
			Statement st = co.createStatement();
			ResultSet rs = st.executeQuery("SELECT * FROM " + table);
			ResultSetMetaData rsmd = rs.getMetaData();
			int cnt = rsmd.getColumnCount();

			/*
			 * DISPLAY TABLE
			 */
			// set data
			DefaultTableModel dtm = new DefaultTableModel(); 
			for(int i = 0; i < cnt; i++){
				dtm.addColumn(rsmd.getColumnName(i + 1));
			}
			while(rs.next()){
				String[] data = new String[cnt];
				for(int i = 0; i < cnt; i++){
					data[i] = rs.getString(i + 1);
				}
				dtm.addRow(data);
			}
			JTable jt = new JTable(dtm);

			// set width
			int[] cwidth = {30, 60, 30, 150, 240};
			int twidth = 0;
			TableColumnModel tcm = jt.getColumnModel();
			for(int i = 0; i < cnt; i++){
				tcm.getColumn(i).setPreferredWidth(cwidth[i]);
				twidth += cwidth[i];
			}
			JScrollPane scp = new JScrollPane(jt);
			scp.setPreferredSize(new Dimension(twidth, 400));
			getContentPane().add(scp);
			pack();
			setDefaultCloseOperation(EXIT_ON_CLOSE);
			setVisible(true);

			st.close();
			co.close();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
}
